"""add_classifier_report_idx

Revision ID: 0b10183fde28
Revises: ece8376bc45c
Create Date: 2020-08-31 14:12:45.279293

"""
from alembic import op
from sqlalchemy import text


# revision identifiers, used by Alembic.
revision = "0b10183fde28"
down_revision = "ece8376bc45c"
branch_labels = None
depends_on = None


def upgrade():
    conn = op.get_bind()
    conn.execute(
        text(
            "CREATE INDEX classifier_report_idx on report_classifiers(classifier_id) INCLUDE(report_id)"
        )
    )

    op.drop_index("report_classifiers_report_id idx", table_name="report_classifiers")


def downgrade():
    op.create_index(
        "report_classifiers_report_id idx",
        "report_classifiers",
        ["report_id"],
        unique=False,
    )

    op.drop_index("classifier_report_idx", table_name="report_classifiers")
