"""add indexes for reports foreign keys

Revision ID: 42e02083317e
Revises: 6bf2484780e2
Create Date: 2020-01-08 00:47:50.551853

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "42e02083317e"
down_revision = "6bf2484780e2"
branch_labels = None
depends_on = None


def upgrade():
    op.create_index(
        "ignore_reports_report_id idx", "ignore_reports", ["report_id"], unique=False
    )
    op.create_index("iocs_report_id idx", "iocs", ["report_id"], unique=False)
    op.create_index(
        "report_classifiers_report_id idx",
        "report_classifiers",
        ["report_id"],
        unique=False,
    )
    op.create_index(
        "report_severity_overrides_report_id idx",
        "report_severity_overrides",
        ["report_id"],
        unique=False,
    )
    op.create_index(
        "report_watchlists_report_id idx",
        "report_watchlists",
        ["report_id"],
        unique=False,
    )


def downgrade():
    op.drop_index("report_watchlists_report_id idx", table_name="report_watchlists")
    op.drop_index(
        "report_severity_overrides_report_id idx",
        table_name="report_severity_overrides",
    )
    op.drop_index("report_classifiers_report_id idx", table_name="report_classifiers")
    op.drop_index("iocs_report_id idx", table_name="iocs")
    op.drop_index("ignore_reports_report_id idx", table_name="ignore_reports")
