"""add watchlist create and update timestamps

Revision ID: 6ff596e1d6c3
Revises: 1359d338b211
Create Date: 2018-11-02 11:06:34.353519

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "6ff596e1d6c3"
down_revision = "1359d338b211"
branch_labels = None
depends_on = None


def upgrade():
    op.add_column(
        "watchlists",
        sa.Column(
            "create_timestamp",
            sa.DateTime(timezone=True),
            server_default=sa.text("now()"),
            nullable=False,
        ),
    )
    op.add_column(
        "watchlists",
        sa.Column(
            "last_update_timestamp",
            sa.DateTime(timezone=True),
            server_default=sa.text("now()"),
            nullable=False,
        ),
    )


def downgrade():  # pragma: no cover
    op.drop_column("watchlists", "last_update_timestamp")
    op.drop_column("watchlists", "create_timestamp")
