"""

Revision ID: f621ab65bf42
Revises: 35edbc4fbde0
Create Date: 2019-01-28 13:41:13.789791

"""
from alembic import op
from sqlalchemy import text

from feed_manager.sql.models import Watchlist, Feed


# revision identifiers, used by Alembic.
revision = "f621ab65bf42"
down_revision = "35edbc4fbde0"
branch_labels = None
depends_on = None


def upgrade():
    # convert all report tags to json arrays
    conn = op.get_bind()
    counter = 0

    # update watchlist names so there are no duplicates
    while True:
        result = conn.execute(
            text(
                "SELECT * FROM (SELECT org_id, name, COUNT(*) AS c from watchlists GROUP BY(org_id, name)) AS hi WHERE c > 1"
            )
        )
        if len(result.fetchall()) < 1:
            break
        else:
            for result in conn.execute(
                text(
                    "SELECT * FROM (SELECT org_id, name, COUNT(*) AS c from watchlists GROUP BY(org_id, name)) AS hi WHERE c > 1 ORDER BY (org_id, name)"
                )
            ):
                counter = 0
                for record in conn.execute(
                    text(
                        f"SELECT id, name, org_id FROM watchlists WHERE name = '{result['name']}' AND org_id = '{result['org_id']}' LIMIT {result['c'] - 1}"
                    )
                ):
                    update_stmt = (
                        Watchlist.__table__.update()
                        .values({"name": f"{record['name']}-{counter}"})
                        .where(Watchlist.id == record["id"])
                    )

                    conn.execute(update_stmt)
                    counter += 1

    # update feed names so there are no duplicates
    while True:
        result = conn.execute(
            text(
                "SELECT * FROM (SELECT owner, name, COUNT(*) AS c from feeds GROUP BY(owner, name)) AS hi WHERE c > 1"
            )
        )
        if len(result.fetchall()) < 1:
            break
        else:
            for result in conn.execute(
                text(
                    "SELECT * FROM (SELECT owner, name, COUNT(*) AS c from feeds GROUP BY(owner, name)) AS hi WHERE c > 1 ORDER BY (owner, name)"
                )
            ):
                counter = 0
                for record in conn.execute(
                    text(
                        f"SELECT id, name, owner FROM feeds WHERE name = '{result['name']}' AND owner = '{result['owner']}' LIMIT {result['c'] - 1}"
                    )
                ):
                    update_stmt = (
                        Feed.__table__.update()
                        .values({"name": f"{record['name']}-{counter}"})
                        .where(Feed.id == record["id"])
                    )

                    conn.execute(update_stmt)
                    counter += 1

    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint("uc_id_owner_access", "feeds", type_="unique")
    op.create_unique_constraint(
        "uc_id_owner_access", "feeds", ["id", "owner", "access"]
    )
    op.create_unique_constraint(None, "feeds", ["owner", "name"])
    op.create_unique_constraint(None, "watchlists", ["name", "org_id"])
    # ### end Alembic commands ###


def downgrade():  # pragma: no cover
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(None, "feeds", type_="unique")
    op.drop_constraint(None, "watchlists", type_="unique")
    op.drop_constraint("uc_id_owner_access", "feeds", type_="unique")
    op.create_unique_constraint(
        "uc_id_owner_access", "feeds", ["id", "owner", "access"]
    )
    # ### end Alembic commands ###
