from typing import NamedTuple, List, Optional

from pscr_common.api.models import with_from_dict

from .feed_models import Report, IOC_V2


@with_from_dict
class WatchlistAction(NamedTuple):
    alert: bool
    tag: bool


@with_from_dict
class AugmentedWatchlist(NamedTuple):
    id: str
    name: str
    action: WatchlistAction
    reports: List[Report]
    hash: str
    alert_classification_enabled: bool


@with_from_dict
class WatchlistMeta(NamedTuple):
    id: str
    name: str
    alert: bool
    tag: Optional[bool]
    alert_classification_enabled: Optional[bool]


@with_from_dict
class AugmentedReport(NamedTuple):
    id: str
    watchlists: List[str]
    timestamp: int
    link: str
    title: str
    description: str
    severity: int
    tags: Optional[str]
    iocs: List[IOC_V2]
    visibility: Optional[str]


@with_from_dict
class AugmentedWatchlists(NamedTuple):
    watchlists: List[WatchlistMeta]
    reports: List[AugmentedReport]
    hash: str
