import re

from pscr_common.api.models import ValidationError

VALID_ID_RE = re.compile(r"^[\w.-]+$", re.ASCII)


class InvalidReportSeverity(ValidationError):
    def __init__(self, val):
        super(InvalidReportSeverity, self).__init__(
            f"Report severity '{val}' must be between 1 and 10"
        )


class InvalidReportId(ValidationError):
    def __init__(self, report_id):
        super(InvalidReportId, self).__init__(
            f"Report Id '{report_id}' must be alphanumeric with underscore, dash or period "
        )


class InvalidIOCId(ValidationError):
    def __init__(self, report_id):
        super(InvalidIOCId, self).__init__(
            f"IOC Id '{report_id}' must be alphanumeric with underscore, dash or period"
        )
