# pragma: no cover
import os
from feed_manager.utils.config import Config
from feed_manager.sql.migrate import db_upgrade
import asyncio
import multiprocessing

try:
    import uvloop

    uvloop_found = True
except ImportError:
    uvloop_found = False


listen_port = os.environ.get("BIND_PORT", "5000")

bind = [f"[::]:{listen_port}"]

worker_class = (
    "aiohttp.GunicornUVLoopWebWorker" if uvloop_found else "aiohttp.GunicornWebWorker"
)
workers = int(
    os.environ.get("GUNICORN_NUM_WORKERS", multiprocessing.cpu_count() * 2 + 1)
)

accesslog = "-"  # access log to stdout

timeout = 30


def on_starting(_server):
    config = Config.create()
    loop = asyncio.get_event_loop()
    loop.run_until_complete(db_upgrade(config))
